package com.antai.sport.http.server.server.api.business.course.service;

import com.antai.sport.http.server.common.service.CommonCodeService;
import com.antai.sport.http.server.common.vo.SysCodeDetailVO;
import com.antai.sport.http.server.constants.CourseType;
import com.antai.sport.http.server.server.api.business.course.mapper.CourseBusinessMapper;
import com.antai.sport.http.server.server.api.business.course.vo.CourseItemVO;
import com.antai.sport.http.server.server.api.business.course.vo.CourseTypeVO;
import com.antai.sport.http.server.server.api.business.course.vo.CourseVO;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class CourseService {
    @Resource
    private CommonCodeService commonCodeService;
    @Resource
    private CourseBusinessMapper courseBusinessMapper;

    public List<CourseTypeVO> getCourseTree() {
        List<CourseTypeVO> resultList = new ArrayList<>();
        List<CourseVO> courseList = courseBusinessMapper.getCourseList();
        if (!courseList.isEmpty()) {
            Map<String, List<SysCodeDetailVO>> codeMap = commonCodeService.getCodeByTypes(CourseType.CODE);
            List<SysCodeDetailVO> courseTypeList = codeMap.get(CourseType.CODE);
            Map<Integer, CourseTypeVO> courseTypeMap = new HashMap<>();
            for (SysCodeDetailVO item : courseTypeList) {
                CourseTypeVO courseType = new CourseTypeVO();
                courseType.setName(item.getName());
                courseType.setCourseList(new ArrayList<>());
                courseTypeMap.put(item.getValue(), courseType);
                resultList.add(courseType);
            }
            for (CourseVO course : courseList) {
                if (courseTypeMap.containsKey(course.getType())) {
                    courseTypeMap.get(course.getType()).getCourseList().add(course);
                }
            }
        }
        return resultList;
    }

    public List<CourseItemVO> getCourseItemList(Long courseId) {
        return courseBusinessMapper.getCourseItemList(courseId);
    }
}
